Description: replace error() with pd_error()
 error() has been removed and -Werror=implicit-function-declaration leads to
 FTBFS
Author: IOhannes m zmölnig
Origin: Debian
Forwarded: no
Last-Update: 2024-03-16 
---
This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
--- pd-mrpeach.orig/binfile/binfile.c
+++ pd-mrpeach/binfile/binfile.c
@@ -100,7 +100,7 @@
 
     if (x == NULL)
     {
-        error("binfile: Could not create...");
+        pd_error(x, "binfile: Could not create...");
         return x;
     }
     x->x_fP = NULL;
@@ -128,7 +128,7 @@
         }
     }
     if ((x->x_buf = getbytes(x->x_buf_length)) == NULL)
-        error ("binfile: Unable to allocate %lu bytes for buffer", x->x_buf_length);
+        pd_error(x, "binfile: Unable to allocate %lu bytes for buffer", x->x_buf_length);
     x->x_bin_outlet = outlet_new(&x->x_obj, gensym("float"));
     x->x_info_outlet = outlet_new(&x->x_obj, gensym("list"));
     x->x_bang_outlet = outlet_new(&x->x_obj, gensym("bang")); /* bang at end of file */
@@ -186,7 +186,7 @@
     size_t bytes_written = 0L;
 
     if (0==(x->x_fP = binfile_open_path(x, path->s_name, "wb")))
-        error("binfile: Unable to open %s for writing", path->s_name);
+        pd_error(x, "binfile: Unable to open %s for writing", path->s_name);
     bytes_written = fwrite(x->x_buf, 1L, x->x_length, x->x_fP);
     if (bytes_written != x->x_length) post("binfile: %ld bytes written != %ld", bytes_written, x->x_length);
     else post("binfile: wrote %ld bytes to %s", bytes_written, path->s_name);
@@ -203,7 +203,7 @@
 
     if (0==(x->x_fP = binfile_open_path(x, path->s_name, "rb")))
     {
-        error("binfile: Unable to open %s for reading", path->s_name);
+        pd_error(x, "binfile: Unable to open %s for reading", path->s_name);
         return;
     }
     /* get length of file up to max_bytes */
@@ -217,7 +217,7 @@
     if (NULL == x->x_buf)
     {
         x->x_buf_length = 0L;
-        error ("binfile: unable to allocate %ld bytes for %s", file_length, path->s_name);
+        pd_error(x, "binfile: unable to allocate %ld bytes for %s", file_length, path->s_name);
         return;
     }
     x->x_rd_offset = 0L;
@@ -267,12 +267,12 @@
             f = atom_getfloat(&argv[i]);
             if (j < -128 || j > 255)
             {
-                error("binfile: input (%d) out of range [0..255]", j);
+                pd_error(x, "binfile: input (%d) out of range [0..255]", j);
                 return;
             }
             if (j != f)
             {
-                error("binfile: input (%f) not an integer", f);
+                pd_error(x, "binfile: input (%f) not an integer", f);
                 return;
             }
             if (x->x_buf_length <= x->x_wr_offset)
@@ -280,7 +280,7 @@
                 x->x_buf = resizebytes(x->x_buf, x->x_buf_length, x->x_buf_length+ALLOC_BLOCK_SIZE);
                 if (x->x_buf == NULL)
                 {
-                    error("binfile: unable to resize buffer");
+                    pd_error(x, "binfile: unable to resize buffer");
                     return;
                 }
                 x->x_buf_length += ALLOC_BLOCK_SIZE;
@@ -290,7 +290,7 @@
         }
         else
         {
-            error("binfile: input %d not a float", i);
+            pd_error(x, "binfile: input %d not a float", i);
             return;
         }
     }
--- pd-mrpeach.orig/life2x/life2x.c
+++ pd-mrpeach/life2x/life2x.c
@@ -372,21 +372,21 @@
         if (s->s_name[i] == '/') break;
         if ((s->s_name[i] < 0x30)||(s->s_name[i] > 0x38))
         {
-            error("life2x_rule: bad character in rule: %c", s->s_name[i]);
+            pd_error(x, "life2x_rule: bad character in rule: %c", s->s_name[i]);
             return;
         }
         survive[s->s_name[i]-0x30] = 1;
     }
     if (s->s_name[i] != '/')
     {
-        error("life2x_rule: missing / separator");
+        pd_error(x, "life2x_rule: missing / separator");
         return;
     }
     for (++i; s->s_name[i] != 0; ++i)
     {
         if ((s->s_name[i] < 0x30)||(s->s_name[i] > 0x38))
         {
-            error("life2x_rule: bad character in rule: %c", s->s_name[i]);
+            pd_error(x, "life2x_rule: bad character in rule: %c", s->s_name[i]);
             return;
         }
         born[s->s_name[i]-0x30] = 1;
@@ -512,7 +512,7 @@
 
     if (n < 0)
     {
-        error("life2x: novar argument must be positive");
+        pd_error(x, "life2x: novar argument must be positive");
         return;
     }
     else
@@ -552,12 +552,12 @@
             x->l_xcellnum = av[0].a_w.w_float; /* arg sets # of horiz cells */
             if (x->l_xcellnum < 4)
             {
-                error("Life: first argument < 4, set to 4");
+                pd_error(x, "Life: first argument < 4, set to 4");
                 x->l_xcellnum = 4; /* min # of  horiz cells */
             }
             if (x->l_xcellnum > MAXSIZE)
             {
-                error("Life: first argument > %d, set to %d", MAXSIZE, MAXSIZE);
+                pd_error(x, "Life: first argument > %d, set to %d", MAXSIZE, MAXSIZE);
                 x->l_xcellnum = MAXSIZE; /* max # of horiz cells */
             }
             /* if 2 arguments */
@@ -566,18 +566,18 @@
                 x->l_ycellnum = av[1].a_w.w_float; /* 2nd arg sets # of verti cells */
                 if (x->l_ycellnum < 4)
                 {
-                    error("Life: 2nd argument < 4, set to 4");
+                    pd_error(x, "Life: 2nd argument < 4, set to 4");
                     x->l_ycellnum = 4; /* min # of verti cells */
                 }
                 if (x->l_ycellnum > MAXSIZE)
                 {
-                    error("Life: 2nd argument > %d, set to %d", MAXSIZE, MAXSIZE);
+                    pd_error(x, "Life: 2nd argument > %d, set to %d", MAXSIZE, MAXSIZE);
                     x->l_ycellnum = MAXSIZE; /* max # of verti cells */
                 }
             }
             else if (ac > 1)
             { /* if 2nd arg not an int */
-                error("Life: 2nd argument must be int");
+                pd_error(x, "Life: 2nd argument must be int");
                 x->l_ycellnum = DEFAULT_DIM; /* default # of verti cells */
             }
             else
@@ -587,7 +587,7 @@
         }
         else
         { /*if first arg not an int */
-            error("Life: first argument must be int");
+            pd_error(x, "Life: first argument must be int");
             x->l_xcellnum = DEFAULT_DIM; /* default # of horiz cells */
             x->l_ycellnum = DEFAULT_DIM; /* default # of verti cells */
         }
@@ -611,7 +611,7 @@
         || (x->gen_shift_ptr == NULL)
     )
     {
-        error ("Unable to allocate memory for the life array (%luX%lu needs %lu bytes)",
+        pd_error (x, "Unable to allocate memory for the life array (%luX%lu needs %lu bytes)",
             x->l_xcellnum, x->l_ycellnum, x->l_cellmax*4L);
         life2x_free (x);
         return x;
@@ -620,7 +620,7 @@
     x->l_column_list = getbytes(x->l_ycellnum*sizeof (t_atom));
     if (x->l_column_list == NULL)
     {
-        error("life2x_new: Unable to allocate %lu bytes for column list",
+        pd_error(x, "life2x_new: Unable to allocate %lu bytes for column list",
         x->l_ycellnum*sizeof (t_atom));
         life2x_free (x);
         return x;
@@ -653,7 +653,7 @@
     x->l_cellouts = getbytes(x->l_xcellnum*sizeof (t_outlet*));
     if (x->l_cellouts == NULL)
     {
-        error("life2x_new: Unable to allocate %lu bytes for column outlets",
+        pd_error(x, "life2x_new: Unable to allocate %lu bytes for column outlets",
         x->l_xcellnum*sizeof (t_outlet*));
         life2x_free (x);
         return x;
--- pd-mrpeach.orig/midifile/midifile.c
+++ pd-mrpeach/midifile/midifile.c
@@ -199,7 +199,7 @@
 
     if (x == NULL)
     {
-        error("midifile: Could not create...");
+        pd_error(x, "midifile: Could not create...");
         return x;
     }
     x->fP = NULL;
@@ -228,7 +228,7 @@
                     x->state = mfReading;
                     if (midifile_read_chunks(x) == 0) midifile_free_file(x);
                 }
-                else error("midifile: unable to open %s", pathSymbol->s_name);
+                else pd_error(x, "midifile: unable to open %s", pathSymbol->s_name);
                 break;
             }
         }
@@ -858,7 +858,7 @@
         x->state = mfReading;
         if (midifile_read_chunks(x) == 0) midifile_free_file(x); // 
     }
-    else error("midifile: Unable to open %s", path->s_name);
+    else pd_error(x, "midifile: Unable to open %s", path->s_name);
 }
 
 /** midifile_bang steps forward one tick and processes all tracks for that tick.
@@ -934,12 +934,12 @@
     if (x->state != mfWriting) return;/* list only works for writing */
     if (x->tmpFP[x->track] == NULL)
     {
-        if (0 == warnings++) error ("midifile: no file is open for writing");
+        if (0 == warnings++) pd_error(x, "midifile: no file is open for writing");
         return;
     }
     if (0 != x->track_chunk[x->track].track_ended)
     {
-        if (0 == warnings++) error ("midifile: track %d is ended", x->track);
+        if (0 == warnings++) pd_error(x, "midifile: track %d is ended", x->track);
         return;
     }
     for (i = 0; i < argc; ++i)
@@ -970,7 +970,7 @@
                         {
                             if (argv[k].a_type != A_FLOAT)
                             {
-                                error ("midifile: sysex list must be all floats");
+                                pd_error(x, "midifile: sysex list must be all floats");
                                 x->track_chunk[x->track].chunk_length += written;
                                 return;
                             }
@@ -979,7 +979,7 @@
                         }
                         if (m != 0xF7)
                         {
-                            error ("midifile: sysex list terminator is 0x%X", m);
+                            pd_error(x, "midifile: sysex list terminator is 0x%X", m);
                             x->track_chunk[x->track].chunk_length += written;
                             return;
                         }
@@ -1119,7 +1119,7 @@
 
     if (x->fP == NULL)
     {
-        error("midifile: no open file");
+        pd_error(x, "midifile: no open file");
         return 0;/* no open file */
     }
     rewind(x->fP);
@@ -1128,13 +1128,13 @@
     x->offset += n;
     if (n != 4L)
     {
-        error("midifile: read %d instead of 4", n);
+        pd_error(x, "midifile: read %d instead of 4", n);
         return 0;
     }
     if (x->verbosity) post("midifile: Header chunk type: %c%c%c%c", cP[0], cP[1], cP[2], cP[3]);
     if (!(cP[0] == 'M' && cP[1] == 'T' && cP[2] == 'h' && cP[3] == 'd'))
     {
-        error ("midifile: bad file format: bad header chunk type");
+        pd_error(x, "midifile: bad file format: bad header chunk type");
         return 0;
     }
     cP = (unsigned char *)buf;
@@ -1142,21 +1142,21 @@
     x->offset += n;
     if (n != 4L)
     {
-        error("midifile: read %d instead of 4", n);
+        pd_error(x, "midifile: read %d instead of 4", n);
         return 0;
     }
     x->header_chunk.chunk_length = midifile_get_multibyte_4(cP);
     if (x->verbosity) post("midifile: Header chunk length: %lu", x->header_chunk.chunk_length);
     if (x->header_chunk.chunk_length != 6L)
     {
-        error ("midifile: bad file format: bad header chunk length");
+        pd_error(x, "midifile: bad file format: bad header chunk length");
         return 0;
     }
     n = fread(cP, 1L, 2L, x->fP);
     x->offset += n;
     if (n != 2L)
     {
-        error("midifile: read %d instead of 2", n);
+        pd_error(x, "midifile: read %d instead of 2", n);
         return 0;
     }
     x->header_chunk.chunk_format = midifile_get_multibyte_2(cP);
@@ -1182,7 +1182,7 @@
     x->offset += n;
     if (n != 2L)
     {
-        error("midifile: read %d instead of 2", n);
+        pd_error(x, "midifile: read %d instead of 2", n);
         return 0;
     }
     x->header_chunk.chunk_ntrks = midifile_get_multibyte_2(cP);
@@ -1191,7 +1191,7 @@
     outlet_anything( x->status_outlet, gensym("tracks"), 1, &output_atom);
     if (x->header_chunk.chunk_ntrks > MAX_TRACKS)
     {
-        error ("midifile: Header chunk ntrks (%d) exceeds midifile MAX_TRACKS, set to %d",
+        pd_error(x, "midifile: Header chunk ntrks (%d) exceeds midifile MAX_TRACKS, set to %d",
             x->header_chunk.chunk_ntrks, MAX_TRACKS);
         x->header_chunk.chunk_ntrks = MAX_TRACKS;
     }
@@ -1199,7 +1199,7 @@
     x->offset += n;
     if (n != 2L)
     {
-        error("midifile: read %d instead of 2", n);
+        pd_error(x, "midifile: read %d instead of 2", n);
         return 0;
     }
     x->header_chunk.chunk_division = midifile_get_multibyte_2(cP);
@@ -1240,19 +1240,19 @@
 
     if (x->fP == NULL)
     {
-        error("midifile: no open file");
+        pd_error(x, "midifile: no open file");
         return 0;/* no open file */
     }
     n = fread(cP, 1L, 4L, x->fP);
     x->offset += n;
     if (n != 4L)
     {
-        error("midifile: read %d instead of 4", n);
+        pd_error(x, "midifile: read %d instead of 4", n);
         return 0;
     }
     if (!(cP[0] == 'M' && cP[1] == 'T' && cP[2] == 'r' && cP[3] == 'k'))
     {
-        error ("midifile: bad file format: bad track chunk type");
+        pd_error(x, "midifile: bad file format: bad track chunk type");
         return 0;
     }
     type[0] = cP[0];
@@ -1265,7 +1265,7 @@
     x->offset += n;
     if (n != 4L)
     {
-        error("midifile: read %d instead of 4", n);
+        pd_error(x, "midifile: read %d instead of 4", n);
         return 0;
     }
     len = midifile_get_multibyte_4(cP);
@@ -1273,7 +1273,7 @@
     if (x->verbosity) post("midifile: Track chunk %d type: %s, length %d", mfTrack, type, len);
     if ((cP = getbytes(len)) == NULL)
     {
-        error ("midifile: Unable to allocate %d bytes for track data", len);
+        pd_error(x, "midifile: Unable to allocate %d bytes for track data", len);
         return 0;
     }
     x->track_chunk[mfTrack].track_data = (unsigned char*)cP;	
@@ -1511,7 +1511,7 @@
     slist = getbytes (slen);
     if (slist == NULL)
     {
-        error ("midifile: no memory for long list");
+        pd_error(0, "midifile: no memory for long list");
         return;
     }
     slist[0].a_type = A_FLOAT;
@@ -2060,7 +2060,7 @@
             x->midi_data[2].a_w.w_float	= (n == 3)?d:0;
             if (x->midi_data[0].a_w.w_float != 0) outlet_list(x->midi_list_outlet, &s_list, n, x->midi_data);
             if (x->track_chunk[mfTrack].running_status == 0)
-                error ("midifile: No running status on track %d at %d",
+                pd_error(x, "midifile: No running status on track %d at %d",
                     mfTrack, x->track_chunk[mfTrack].total_time + delta_time);
         }
     }
--- pd-mrpeach.orig/net/tcpclient.c
+++ pd-mrpeach/net/tcpclient.c
@@ -292,7 +292,7 @@
     /* if we are not already connected, as Ivica Ico Bukvic 5/5/10 <ico@bukvic.net> noted */
     if (0 != x->x_connectstate)
     {
-        error("%s_connect: already connected to %s:%d on socket %d", objName, x->x_hostname, x->x_port, x->x_fd);
+        pd_error(x, "%s_connect: already connected to %s:%d on socket %d", objName, x->x_hostname, x->x_port, x->x_fd);
         return;
     }
     /* we get hostname and port and pass them on
--- pd-mrpeach.orig/net/tcpsend.c
+++ pd-mrpeach/net/tcpsend.c
@@ -61,7 +61,7 @@
 
     if (x->x_fd >= 0)
     {
-        error("tcpsend: already connected");
+        pd_error(x, "tcpsend: already connected");
         return;
     }
 
--- pd-mrpeach.orig/net/tcpserver.c
+++ pd-mrpeach/net/tcpserver.c
@@ -207,7 +207,7 @@
     t_tcpserver_socketreceiver *x = (t_tcpserver_socketreceiver *)getbytes(sizeof(*x));
     if (!x)
     {
-        error("%s_socketreceiver: unable to allocate %zu bytes", objName, sizeof(*x));
+        pd_error(x, "%s_socketreceiver: unable to allocate %zu bytes", objName, sizeof(*x));
     }
     else
     {
@@ -219,7 +219,7 @@
         {
             freebytes(x, sizeof(*x));
             x = NULL;
-            error("%s_socketreceiver: unable to allocate %ld bytes", objName, INBUFSIZE);
+            pd_error(x, "%s_socketreceiver: unable to allocate %ld bytes", objName, INBUFSIZE);
         }
     }
     return (x);
@@ -358,12 +358,12 @@
         /* sender thread should start out detached so its resouces will be freed when it is done */
         if (0!= (sender_thread_result = pthread_attr_init(&sender_attr)))
         {
-            error("%s: pthread_attr_init failed: %d", objName, sender_thread_result);
+            pd_error(x, "%s: pthread_attr_init failed: %d", objName, sender_thread_result);
             goto failed;
         }
         if(0!= (sender_thread_result = pthread_attr_setdetachstate(&sender_attr, PTHREAD_CREATE_DETACHED)))
         {
-            error("%s: pthread_attr_setdetachstate failed: %d", objName, sender_thread_result);
+            pd_error(x, "%s: pthread_attr_setdetachstate failed: %d", objName, sender_thread_result);
             goto failed;
         }
         for (i = j = 0; i < argc; ++i)
@@ -376,12 +376,12 @@
                 if (x->x_verbosity > 2) post("%s: argv[%d]: float:%f int:%d delta:%f", objName, i, f, d, e);
                 if (e != 0)
                 {
-                    error("%s: item %d (%f) is not an integer", objName, i, f);
+                    pd_error(x, "%s: item %d (%f) is not an integer", objName, i, f);
                     goto failed;
                 }
                 if ((d < 0) || (d > 255))
                 {
-                    error("%s: item %d (%f) is not between 0 and 255", objName, i, f);
+                    pd_error(x, "%s: item %d (%f) is not between 0 and 255", objName, i, f);
                     goto failed;
                 }
                 c = (unsigned char)d; /* make sure it doesn't become negative; this only matters for post() */
@@ -392,14 +392,14 @@
 #ifdef SIOCOUTQ
                     if (tcpserver_send_buffer_avaliable_for_client(x, client) < j)
                     {
-                        error("%s: buffer too small for client(%d)", objName, client);
+                        pd_error(x, "%s: buffer too small for client(%d)", objName, client);
                         goto failed;
                     }
 #endif // SIOCOUTQ
                     ttsp = (t_tcpserver_send_params *)getbytes(sizeof(t_tcpserver_send_params));
                     if (ttsp == NULL)
                     {
-                        error("%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
+                        pd_error(x, "%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
                         goto failed;
                     }
                     ttsp->client = client;
@@ -410,7 +410,7 @@
                     if (0 != (sender_thread_result = pthread_create(&sender_thread, &sender_attr, tcpserver_send_buf_thread, (void *)ttsp)))
                     {
                         ++x->x_blocked;
-                        error("%s: couldn't create sender thread (%d)", objName, sender_thread_result);
+                        pd_error(x, "%s: couldn't create sender thread (%d)", objName, sender_thread_result);
                         if (NULL != ttsp)
                         {
                             freebytes (ttsp, sizeof (t_tcpserver_send_params));
@@ -430,7 +430,7 @@
                 fptr = sys_fopen(fpath, "rb");
                 if (fptr == NULL)
                 {
-                    error("%s: unable to open \"%s\"", objName, fpath);
+                    pd_error(x, "%s: unable to open \"%s\"", objName, fpath);
                     goto failed;
                 }
                 rewind(fptr);
@@ -445,14 +445,14 @@
 #ifdef SIOCOUTQ
                         if (tcpserver_send_buffer_avaliable_for_client(x, client) < j)
                         {
-                            error("%s: buffer too small for client(%d)", objName, client);
+                            pd_error(x, "%s: buffer too small for client(%d)", objName, client);
                             goto failed;
                         }
 #endif // SIOCOUTQ
                         ttsp = (t_tcpserver_send_params *)getbytes(sizeof(t_tcpserver_send_params));
                         if (ttsp == NULL)
                         {
-                            error("%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
+                            pd_error(x, "%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
                             goto failed;
                         }
                         ttsp->client = client;
@@ -463,7 +463,7 @@
                         if ( 0!= (sender_thread_result = pthread_create(&sender_thread, &sender_attr, tcpserver_send_buf_thread, (void *)ttsp)))
                         {
                             ++x->x_blocked;
-                            error("%s: couldn't create sender thread (%d)", objName, sender_thread_result);
+                            pd_error(x, "%s: couldn't create sender thread (%d)", objName, sender_thread_result);
                             if (NULL != ttsp)
                             {
                                 freebytes (ttsp, sizeof (t_tcpserver_send_params));
@@ -482,7 +482,7 @@
             }
             else
             { /* arg was neither a float nor a valid file name */
-                error("%s: item %d is not a float or a file name", objName, i);
+                pd_error(x, "%s: item %d is not a float or a file name", objName, i);
                 goto failed;
             }
         }
@@ -492,14 +492,14 @@
 #ifdef SIOCOUTQ
             if (tcpserver_send_buffer_avaliable_for_client(x, client) < length)
             {
-                error("%s: buffer too small for client(%d)", objName, client);
+                pd_error(x, "%s: buffer too small for client(%d)", objName, client);
                 goto failed;
             }
 #endif // SIOCOUTQ
             ttsp = (t_tcpserver_send_params *)getbytes(sizeof(t_tcpserver_send_params));
             if (ttsp == NULL)
             {
-                error("%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
+                pd_error(x, "%s: unable to allocate %zu bytes for t_tcpserver_send_params", objName, sizeof(t_tcpserver_send_params));
                 goto failed;
             }
             ttsp->client = client;
@@ -510,7 +510,7 @@
             if ( 0!= (sender_thread_result = pthread_create(&sender_thread, &sender_attr, tcpserver_send_buf_thread, (void *)ttsp)))
             {
                 ++x->x_blocked;
-                error("%s: couldn't create sender thread (%d)", objName, sender_thread_result);
+                pd_error(x, "%s: couldn't create sender thread (%d)", objName, sender_thread_result);
                 if (NULL != ttsp) 
                 {
                     freebytes (ttsp, sizeof (t_tcpserver_send_params));
@@ -525,7 +525,7 @@
 failed:
     if (0!= (sender_thread_result = pthread_attr_destroy(&sender_attr)))
     {
-        error("%s_broadcast: pthread_attr_destroy failed: %d", objName, sender_thread_result);
+        pd_error(x, "%s_broadcast: pthread_attr_destroy failed: %d", objName, sender_thread_result);
     }
 
     SETFLOAT(&output_atom[0], client+1);
@@ -845,6 +845,7 @@
 //    pthread_attr_t                  sender_attr;
 //    int                             sender_thread_result;
     int                             result;
+    t_tcpserver *x = ttbp->x;
 
     for (i = j = 0; i < ttbp->argc; ++i)
     {
@@ -856,13 +857,13 @@
             if (ttbp->x->x_verbosity > 1) post("%s: argv[%d]: float:%f int:%d delta:%f", objName, i, f, d, e);
             if (e != 0)
             {
-                error("%s_broadcast_thread: item %d (%f) is not an integer", objName, i, f);
+                pd_error(x, "%s_broadcast_thread: item %d (%f) is not an integer", objName, i, f);
                 if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                 return NULL;
             }
             if ((d < 0) || (d > 255))
             {
-                error("%s_broadcast_thread: item %d (%f) is not between 0 and 255", objName, i, f);
+                pd_error(x, "%s_broadcast_thread: item %d (%f) is not between 0 and 255", objName, i, f);
                 if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                 return NULL;
             }
@@ -878,7 +879,7 @@
 #ifdef SIOCOUTQ
                     if (tcpserver_send_buffer_avaliable_for_client(ttbp->x, client) < j)
                     {
-                        error("%s_broadcast_thread: buffer too small for client(%d)", objName, client);
+                        pd_error(x, "%s_broadcast_thread: buffer too small for client(%d)", objName, client);
                         if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                         return NULL;
                     }
@@ -907,7 +908,7 @@
             fptr = sys_fopen(fpath, "rb");
             if (fptr == NULL)
             {
-                error("%s_broadcast_thread: unable to open \"%s\"", objName, fpath);
+                pd_error(x, "%s_broadcast_thread: unable to open \"%s\"", objName, fpath);
                 if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                 return NULL;
             }
@@ -927,7 +928,7 @@
 #ifdef SIOCOUTQ
                         if (tcpserver_send_buffer_avaliable_for_client(x, client) < j)
                         {
-                            error("%s_broadcast_thread: buffer too small for client(%d)", objName, client);
+                            pd_error(x, "%s_broadcast_thread: buffer too small for client(%d)", objName, client);
                             if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                             return NULL;
                         }
@@ -956,7 +957,7 @@
         }
         else
         { /* arg was neither a float nor a valid file name */
-            error("%s_broadcast_thread: item %d is not a float or a file name", objName, i);
+            pd_error(x, "%s_broadcast_thread: item %d is not a float or a file name", objName, i);
             if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
             return NULL;
         }
@@ -970,7 +971,7 @@
 #ifdef SIOCOUTQ
             if (tcpserver_send_buffer_avaliable_for_client(x, client) < length)
             {
-                error("%s_broadcast_thread: buffer too small for client(%d)", objName, client);
+                pd_error(x, "%s_broadcast_thread: buffer too small for client(%d)", objName, client);
                 if (NULL != arg) freebytes (arg, sizeof (t_tcpserver_broadcast_params));
                 return NULL;
             }
@@ -1010,20 +1011,20 @@
         /* sender thread should start out detached so its resouces will be freed when it is done */
         if (0!= (broadcast_thread_result = pthread_attr_init(&broadcast_attr)))
         {
-            error("%s_broadcast: pthread_attr_init failed: %d", objName, broadcast_thread_result);
+            pd_error(x, "%s_broadcast: pthread_attr_init failed: %d", objName, broadcast_thread_result);
         }
         else
         {
             if(0 != (broadcast_thread_result = pthread_attr_setdetachstate(&broadcast_attr, PTHREAD_CREATE_DETACHED)))
             {
-                error("%s_broadcast: pthread_attr_setdetachstate failed: %d", objName, broadcast_thread_result);
+                pd_error(x, "%s_broadcast: pthread_attr_setdetachstate failed: %d", objName, broadcast_thread_result);
             }
             else
             {
                 ttbp = (t_tcpserver_broadcast_params *)getbytes(sizeof(t_tcpserver_broadcast_params));
                 if (ttbp == NULL)
                 {
-                    error("%s_broadcast: unable to allocate %zu bytes for t_tcpserver_broadcast_params", objName, sizeof(t_tcpserver_broadcast_params));
+                    pd_error(x, "%s_broadcast: unable to allocate %zu bytes for t_tcpserver_broadcast_params", objName, sizeof(t_tcpserver_broadcast_params));
                 }
                 else
                 {
@@ -1032,7 +1033,7 @@
                     for (i = 0; i < argc; i++) ttbp->argv[i] = argv[i];
                     if (0 != (broadcast_thread_result = pthread_create(&broadcast_thread, &broadcast_attr, tcpserver_broadcast_thread, (void *)ttbp)))
                     {
-                        error("%s_broadcast: couldn't create broadcast thread (%d)", objName, broadcast_thread_result);
+                        pd_error(x, "%s_broadcast: couldn't create broadcast thread (%d)", objName, broadcast_thread_result);
                         if (NULL != ttbp)
                         {
                             freebytes (ttbp, sizeof (t_tcpserver_broadcast_params));
@@ -1043,7 +1044,7 @@
             }
             if (0!= (broadcast_thread_result = pthread_attr_destroy(&broadcast_attr)))
             {
-                error("%s_broadcast: pthread_attr_destroy failed: %d", objName, broadcast_thread_result);
+                pd_error(x, "%s_broadcast: pthread_attr_destroy failed: %d", objName, broadcast_thread_result);
             }
         }
     }
--- pd-mrpeach.orig/net/udpreceive~.c
+++ pd-mrpeach/net/udpreceive~.c
@@ -216,14 +216,14 @@
         {
             /* incomplete header tag: return and try again later */
             /* in the hope that more data will be available */
-            error("udpreceive~: got incomplete header tag");
+            pd_error(x, "udpreceive~: got incomplete header tag");
             return;
         }
         /* make sure this is really a tag */
         if (!((tag_ptr->tag[0] == 'T')&&(tag_ptr->tag[1] == 'A')&&(tag_ptr->tag[2] == 'G')&&(tag_ptr->tag[3] == '!')))
         {
             ++x->x_tag_errors;
-            if (x->x_sync) error("udpreceive~: bad header tag (%d)", x->x_tag_errors);
+            if (x->x_sync) pd_error(x, "udpreceive~: bad header tag (%d)", x->x_tag_errors);
             x->x_sync = 0;
             /* tag length is 16 bytes, a multiple of the data frame size, so eventually we should resync on a tag */
             return;
@@ -235,7 +235,7 @@
         /* get info from header tag */
         if (tag_ptr->channels > (x->x_noutlets-1))
         {
-            error("udpreceive~: incoming stream has too many channels (%d)", tag_ptr->channels);
+            pd_error(x, "udpreceive~: incoming stream has too many channels (%d)", tag_ptr->channels);
             x->x_counter = 0;
             return;
         }
@@ -271,7 +271,7 @@
         {
             if (x->x_frames[x->x_framein].tag.format == SF_AAC)
             {
-                error("udpreceive~: don't know how to decode AAC format");
+                pd_error(x, "udpreceive~: don't know how to decode AAC format");
                 return;
             }
             x->x_counter++;
@@ -556,7 +556,7 @@
 
     if (x->x_blocksize % sp[0]->s_n)
     {
-        error("udpreceive~: signal vector size too large (needs to be even divisor of %d)", x->x_blocksize);
+        pd_error(x, "udpreceive~: signal vector size too large (needs to be even divisor of %d)", x->x_blocksize);
     }
     else
     {
@@ -707,7 +707,7 @@
 
     if (outlets < 1 || outlets > DEFAULT_AUDIO_CHANNELS)
     {
-        error("udpreceive~: Number of channels must be between 1 and %d", DEFAULT_AUDIO_CHANNELS);
+        pd_error(x, "udpreceive~: Number of channels must be between 1 and %d", DEFAULT_AUDIO_CHANNELS);
         return NULL;
     }
 
@@ -726,7 +726,7 @@
     x->x_myvec = (t_int **)t_getbytes(sizeof(t_int *) * (x->x_noutlets + 3));
     if (!x->x_myvec)
     {
-        error("udpreceive~: out of memory");
+        pd_error(x, "udpreceive~: out of memory");
         return NULL;
     }
     x->x_connectsocket = x->x_socket = -1;
@@ -745,7 +745,7 @@
     if (blocksize == 0) x->x_blocksize = DEFAULT_AUDIO_BUFFER_SIZE; 
     else if (DEFAULT_AUDIO_BUFFER_SIZE%(int)blocksize)
     {
-        error("udpreceive~: blocksize must fit snugly in %d", DEFAULT_AUDIO_BUFFER_SIZE);
+        pd_error(x, "udpreceive~: blocksize must fit snugly in %d", DEFAULT_AUDIO_BUFFER_SIZE);
         return NULL;
     } 
     else x->x_blocksize = blocksize; //DEFAULT_AUDIO_BUFFER_SIZE; /* <-- the only place blocksize is set */
@@ -754,7 +754,7 @@
     x->x_buffering = 1;
     if (!udpreceive_tilde_createsocket(x, x->x_addr_name, portno))
     {
-        error("udpreceive~: failed to create listening socket");
+        pd_error(x, "udpreceive~: failed to create listening socket");
         return NULL;
     }
     return (x);
--- pd-mrpeach.orig/net/udpsend~.c
+++ pd-mrpeach/net/udpsend~.c
@@ -725,7 +725,7 @@
 
     if (DEFAULT_AUDIO_BUFFER_SIZE % sp[0]->s_n)
     {
-        error("udpsend~: signal vector size too large (needs to be even divisor of %d)", DEFAULT_AUDIO_BUFFER_SIZE);
+        pd_error(x, "udpsend~: signal vector size too large (needs to be even divisor of %d)", DEFAULT_AUDIO_BUFFER_SIZE);
     }
     else
     {
@@ -845,7 +845,7 @@
 
         if ((int)inlets < 1 || (int)inlets > DEFAULT_AUDIO_CHANNELS)
         {
-            error("udpsend~: Number of channels must be between 1 and %d", DEFAULT_AUDIO_CHANNELS);
+            pd_error(x, "udpsend~: Number of channels must be between 1 and %d", DEFAULT_AUDIO_CHANNELS);
             return NULL;
         }
         x->x_ninlets = (int)inlets;
@@ -859,7 +859,7 @@
         x->x_myvec = (t_int **)t_getbytes(sizeof(t_int *) * (x->x_ninlets + 3));
         if (!x->x_myvec)
         {
-            error("udpsend~: out of memory");
+            pd_error(x, "udpsend~: out of memory");
             return NULL;
         }
 
@@ -878,7 +878,7 @@
         if (blocksize == 0) x->x_blocksize = DEFAULT_AUDIO_BUFFER_SIZE; 
         else if (DEFAULT_AUDIO_BUFFER_SIZE%(int)blocksize)
         {
-            error("udpsend~: blocksize must fit snugly in %d", DEFAULT_AUDIO_BUFFER_SIZE);
+            pd_error(x, "udpsend~: blocksize must fit snugly in %d", DEFAULT_AUDIO_BUFFER_SIZE);
             return NULL;
         } 
         else x->x_blocksize = (int)blocksize; //DEFAULT_AUDIO_BUFFER_SIZE; /* <-- the only place blocksize is set */
--- pd-mrpeach.orig/osc/packOSC.c
+++ pd-mrpeach/osc/packOSC.c
@@ -649,7 +649,7 @@
             return returnVal;
         default:
             atom_string(a, buf, MAXPDSTRING);
-            error("packOSC: atom type %d not implemented (%s)", a->a_type, buf);
+            pd_error(0, "packOSC: atom type %d not implemented (%s)", a->a_type, buf);
             returnVal.type = NOTYPE_osc;
             returnVal.datum.s = NULL;
             return returnVal;
@@ -667,19 +667,19 @@
     /* the atoms must all be bytesl */
     if(a->a_type != A_FLOAT)
     {
-        error("packOSC_blob: all values must be floats");
+        pd_error(0, "packOSC_blob: all values must be floats");
         return returnVal;
     }
     f = atom_getfloat(a);
     i = (int)f;
     if (i != f)
     {
-        error("packOSC_blob: all values must be whole numbers");
+        pd_error(0, "packOSC_blob: all values must be whole numbers");
         return returnVal;
     }
     if ((i < -128) || (i > 255))
     {
-        error("packOSC_blob: all values must be bytes");
+        pd_error(0, "packOSC_blob: all values must be bytes");
         return returnVal;
     }
     returnVal.type = BLOB_osc;
@@ -701,7 +701,7 @@
 #endif
     if ((a->a_type != A_FLOAT))
     {
-      error("packOSC: MIDI parameters must be floats");
+      pd_error(0, "packOSC: MIDI parameters must be floats");
       returnVal.type = NOTYPE_osc;
       returnVal.datum.s = NULL;
       return returnVal;
@@ -712,14 +712,14 @@
 #endif
     if ((i < 2) && (m[i] != (m[i] & 0x0FF)))
     {
-      error("packOSC: MIDI parameters must be less than 256");
+      pd_error(0, "packOSC: MIDI parameters must be less than 256");
       returnVal.type = NOTYPE_osc;
       returnVal.datum.s = NULL;
       return returnVal;
     }
     else if ((i > 1) && (m[i] != (m[i] & 0x07F)))
     {
-      error("packOSC: MIDI parameters must be less than 128");
+      pd_error(0, "packOSC: MIDI parameters must be less than 128");
       returnVal.type = NOTYPE_osc;
       returnVal.datum.s = NULL;
       return returnVal;
@@ -814,7 +814,7 @@
             break;
         default:
             atom_string(a, buf, MAXPDSTRING);
-            error("packOSC: atom type %d not implemented (%s)", a->a_type, buf);
+            pd_error(0, "packOSC: atom type %d not implemented (%s)", a->a_type, buf);
             returnVal.type = NOTYPE_osc;
             returnVal.datum.s = NULL;
             break;
@@ -835,7 +835,7 @@
 
     if (returnVal)
     {
-        error("packOSC: Problem writing address. (%d)", returnVal);
+        pd_error(x, "packOSC: Problem writing address. (%d)", returnVal);
         return returnVal;
     }
     for (j = i = 0; (typeStr[i+1]!= 0) || (j < numArgs); j++, i++)
@@ -932,7 +932,7 @@
                     typeTags[j+1] = 'b';
                     break;
                 default:
-                    error("packOSC: arg %d type is unrecognized(%d)", j, args[j].type);
+                    pd_error(x, "packOSC: arg %d type is unrecognized(%d)", j, args[j].type);
                     break;
             }
         }
@@ -943,7 +943,7 @@
         returnVal = OSC_writeAddressAndTypes(buf, messageName, typeTags);
         if (returnVal)
         {
-            error("packOSC: Problem writing address.");
+            pd_error(x, "packOSC: Problem writing address.");
         }
         freebytes(typeTags, sizeof(char)*(numTags+2));
     }
@@ -1088,7 +1088,7 @@
 {
     if ((bytesNeeded) > OSC_freeSpaceInBuffer(buf))
     {
-        error("packOSC: buffer overflow");
+        pd_error(0, "packOSC: buffer overflow");
         return 1;
     }
     return 0;
@@ -1380,7 +1380,7 @@
     {
         if (arg[i].type != BLOB_osc)
         {
-            error("packOSC: blob element %lu not blob type", i);
+            pd_error(0, "packOSC: blob element %lu not blob type", i);
             return 9;
         }
         b = (unsigned char)((arg[i].datum.i)&0x0FF);/* force int to 8-bit byte */
--- pd-mrpeach.orig/osc/routeOSC.c
+++ pd-mrpeach/osc/routeOSC.c
@@ -173,7 +173,7 @@
 
     if (argc > MAX_NUM)
     {
-        error("* routeOSC: too many arguments: %d (max %d)", argc, MAX_NUM);
+        pd_error(x, "* routeOSC: too many arguments: %d (max %d)", argc, MAX_NUM);
         return 0;
     }
     x->x_num = 0;
@@ -188,13 +188,13 @@
             }
             else
             {
-                error("routeOSC: argument %d does not begin with a slash(/).", i);
+                pd_error(x, "routeOSC: argument %d does not begin with a slash(/).", i);
                 return(0);
             }
         }
         else
         {
-            error("routeOSC: argument %d is not a symbol.", i);
+            pd_error(x, "routeOSC: argument %d is not a symbol.", i);
             return 0;
         }
     }
@@ -531,7 +531,7 @@
             return PatternMatch (pattern, test+1);
         case ']':
         case '}':
-                  error("routeOSC: Spurious %c in pattern \".../%s/...\"",pattern[0], theWholePattern);
+                  pd_error(0, "routeOSC: Spurious %c in pattern \".../%s/...\"",pattern[0], theWholePattern);
             return 0;
         case '[':
             return MatchBrackets (pattern,test);
@@ -557,7 +557,7 @@
 
     if (pattern[1] == 0) 
     {
-        error("routeOSC: Unterminated [ in pattern \".../%s/...\"", theWholePattern);
+        pd_error(0, "routeOSC: Unterminated [ in pattern \".../%s/...\"", theWholePattern);
         return 0;
     }
     if (pattern[1] == '!')
@@ -569,7 +569,7 @@
     {
         if (*p == 0) 
         {
-            error("Unterminated [ in pattern \".../%s/...\"", theWholePattern);
+            pd_error(0, "Unterminated [ in pattern \".../%s/...\"", theWholePattern);
             return 0;
         }
         if (p[1] == '-' && p[2] != 0) 
@@ -594,7 +594,7 @@
     {
         if (*p == 0) 
         {
-            error("Unterminated [ in pattern \".../%s/...\"", theWholePattern);
+            pd_error(0, "Unterminated [ in pattern \".../%s/...\"", theWholePattern);
             return 0;
         }
         p++;
@@ -610,7 +610,7 @@
     {
         if (*restOfPattern == 0) 
         {
-            error("Unterminated { in pattern \".../%s/...\"", theWholePattern);
+            pd_error(0, "Unterminated { in pattern \".../%s/...\"", theWholePattern);
             return 0;
         }
     }
--- pd-mrpeach.orig/slipdec/slipdec.c
+++ pd-mrpeach/slipdec/slipdec.c
@@ -57,7 +57,7 @@
     x->x_slip_buf = (t_atom *)getbytes(sizeof(t_atom)*x->x_slip_max_length);
     if(x->x_slip_buf == NULL)
     {
-        error("slipdec: unable to allocate %lu bytes for x_slip_buf", (long)sizeof(t_atom)*x->x_slip_max_length);
+        pd_error(x, "slipdec: unable to allocate %lu bytes for x_slip_buf", (long)sizeof(t_atom)*x->x_slip_max_length);
         return NULL;
     }
     /* init the slip buf atoms to float type */
--- pd-mrpeach.orig/slipenc/slipenc.c
+++ pd-mrpeach/slipenc/slipenc.c
@@ -89,7 +89,7 @@
     x->x_slip_buf = (t_atom *)getbytes(sizeof(t_atom)*x->x_slip_max_length);
     if(x->x_slip_buf == NULL)
     {
-        error("slipenc: unable to allocate %lu bytes for x_slip_buf", (long)sizeof(t_atom)*x->x_slip_max_length);
+        pd_error(x, "slipenc: unable to allocate %lu bytes for x_slip_buf", (long)sizeof(t_atom)*x->x_slip_max_length);
         return NULL;
     }
     /* Initialize all the slip buf atoms to float type */
--- pd-mrpeach.orig/str/str.c
+++ pd-mrpeach/str/str.c
@@ -329,7 +329,7 @@
 
     if (x->x_buf_end > x->x_buf.s_length-20) /* what's the longest float? */
     {
-        error("str_float_to_buf: string too long.");
+        pd_error(x, "str_float_to_buf: string too long.");
         return;
     }
     /* A float is either an ascii character number or a floating-point string */
--- pd-mrpeach.orig/xbee/packxbee.c
+++ pd-mrpeach/xbee/packxbee.c
@@ -58,13 +58,13 @@
 static void packxbee_API(t_packxbee *x, t_float api)
 {
     if ((api == 1) || (api ==2)) x->x_api_mode = api;
-    else error ("packxbee: api mode must be 1 or 2");
+    else pd_error (x, "packxbee: api mode must be 1 or 2");
 }
 
 static void packxbee_verbosity(t_packxbee *x, t_float verbosity_level)
 {
     if (verbosity_level >= 0) x->x_verbosity = verbosity_level;
-    else error ("packxbee: verbosity_level must be positive");
+    else pd_error (x, "packxbee: verbosity_level must be positive");
 }
 
 static int packxbee_outbuf_add(t_packxbee *x, int index, unsigned char val)
@@ -113,18 +113,18 @@
 
     if (argc < 5)
     {
-        error("packxbee_TX: not enough parameters");
+        pd_error(x, "packxbee_TX: not enough parameters");
         return;
     }
     /* first arg is dest64, a symbol starting with "0x" */
     if (argv[0].a_type != A_SYMBOL)
     {
-        error("packxbee_TX: first argument is not a symbol");
+        pd_error(x, "packxbee_TX: first argument is not a symbol");
         return;
     }
     if ((argv[0].a_w.w_symbol->s_name[0] != '0')||(argv[0].a_w.w_symbol->s_name[1] != 'x'))
     {
-        error("packxbee_TX: first argument is not a hex string beginning with \"0x\"");
+        pd_error(x, "packxbee_TX: first argument is not a hex string beginning with \"0x\"");
         return;
     }
 #ifdef _MSC_VER
@@ -134,7 +134,7 @@
 #endif
     if (result == 0)
     {
-        error("packxbee_TX: first argument is not a hex string");
+        pd_error(x, "packxbee_TX: first argument is not a hex string");
         return;
     }
 #ifdef _MSC_VER
@@ -145,25 +145,25 @@
     /* second arg is dest16 also a symbol starting with "0x" */
     if (argv[1].a_type != A_SYMBOL)
     {
-        error("packxbee_TX: second argument is not a symbol");
+        pd_error(x, "packxbee_TX: second argument is not a symbol");
         return;
     }
     if ((argv[1].a_w.w_symbol->s_name[0] != '0')||(argv[1].a_w.w_symbol->s_name[1] != 'x'))
     {
-        error("packxbee_TX: second argument is not a hex string beginning with \"0x\"");
+        pd_error(x, "packxbee_TX: second argument is not a hex string beginning with \"0x\"");
         return;
     }
     result = sscanf(argv[1].a_w.w_symbol->s_name, "0x%X", &dest16);
     if (result == 0)
     {
-        error("packxbee_TX: second argument is not a hex string");
+        pd_error(x, "packxbee_TX: second argument is not a hex string");
         return;
     }
     if (x->x_verbosity > 1) post ("packxbee_TX: dest16: 0x%X", dest16);
     /* broadcast radius is a single byte as a float */
     if (argv[2].a_type != A_FLOAT)
     {
-        error("packxbee_TX: third argument is not a float");
+        pd_error(x, "packxbee_TX: third argument is not a float");
         return;
     }
     f = argv[2].a_w.w_float;
@@ -171,7 +171,7 @@
     d = ((unsigned int)f)&0x0FF;
     if (f != d)
     {
-        error ("packxbee_TX: third argument is not a positive integer from 0 to 255");
+        pd_error (x, "packxbee_TX: third argument is not a positive integer from 0 to 255");
         return;
     }
     else broadcast_radius = d;
@@ -180,7 +180,7 @@
     /* options is a single byte as a float */
     if (argv[3].a_type != A_FLOAT)
     {
-        error("packxbee_TX: fourth argument is not a float");
+        pd_error(x, "packxbee_TX: fourth argument is not a float");
         return;
     }
     f = argv[3].a_w.w_float;
@@ -188,7 +188,7 @@
     d = ((unsigned int)f)&0x0FF;
     if (f != d)
     {
-        error ("packxbee_TX: fourth argument is not a positive integer from 0 to 255");
+        pd_error (x, "packxbee_TX: fourth argument is not a positive integer from 0 to 255");
         return;
     }
     else options = d;
@@ -241,7 +241,7 @@
             d = ((unsigned int)f)&0x0FF;
             if (f != d)
             {
-                error ("packxbee_TX: argument %d is not a positive integer from 0 to 255", k+1);
+                pd_error (x, "packxbee_TX: argument %d is not a positive integer from 0 to 255", k+1);
                 return;
             }
             floatstring[i++] = d;
@@ -256,7 +256,7 @@
         }
         else
         {
-            error("packxbee_TX: argument %d is not a float or a symbol", k+1);
+            pd_error(x, "packxbee_TX: argument %d is not a float or a symbol", k+1);
             return;
         }
     }
@@ -292,18 +292,18 @@
 
     if (argc < 3)
     {
-        error("packxbee_TX64: not enough parameters");
+        pd_error(x, "packxbee_TX64: not enough parameters");
         return;
     }
     /* first arg is dest64, a symbol starting with "0x" */
     if (argv[0].a_type != A_SYMBOL)
     {
-        error("packxbee_TX64: first argument is not a symbol");
+        pd_error(x, "packxbee_TX64: first argument is not a symbol");
         return;
     }
     if ((argv[0].a_w.w_symbol->s_name[0] != '0')||(argv[0].a_w.w_symbol->s_name[1] != 'x'))
     {
-        error("packxbee_TX64: first argument is not a hex string beginning with \"0x\"");
+        pd_error(x, "packxbee_TX64: first argument is not a hex string beginning with \"0x\"");
         return;
     }
 #ifdef _MSC_VER
@@ -313,7 +313,7 @@
 #endif
     if (result == 0)
     {
-        error("packxbee_TX64: first argument is not a hex string");
+        pd_error(x, "packxbee_TX64: first argument is not a hex string");
         return;
     }
 #ifdef _MSC_VER
@@ -324,7 +324,7 @@
     /* options is a single byte as a float */
     if (argv[1].a_type != A_FLOAT)
     {
-        error("packxbee_TX64: second argument is not a float");
+        pd_error(x, "packxbee_TX64: second argument is not a float");
         return;
     }
     f = argv[1].a_w.w_float;
@@ -332,7 +332,7 @@
     d = ((unsigned int)f)&0x0FF;
     if (f != d)
     {
-        error("packxbee_TX64 second argument is not a positive integer from 0 to 255");
+        pd_error(x, "packxbee_TX64 second argument is not a positive integer from 0 to 255");
         return;
     }
     else options = d;
@@ -378,7 +378,7 @@
             d = ((unsigned int)f)&0x0FF;
             if (f != d)
             {
-                error("packxbee_TX64: argument %d is not a positive integer from 0 to 255", k+1);
+                pd_error(x, "packxbee_TX64: argument %d is not a positive integer from 0 to 255", k+1);
                 return;
             }
             floatstring[i++] = d;
@@ -393,7 +393,7 @@
         }
         else
         {
-            error("packxbee_TX64: argument %d is not a float or a symbol", k+1);
+            pd_error(x, "packxbee_TX64: argument %d is not a float or a symbol", k+1);
             return;
         }
     }
@@ -429,24 +429,24 @@
 
     if (argc < 3)
     {
-        error("packxbee_TX16: not enough parameters");
+        pd_error(x, "packxbee_TX16: not enough parameters");
         return;
     }
     /* first arg is dest16 also a symbol starting with "0x" */
     if (argv[0].a_type != A_SYMBOL)
     {
-        error("packxbee_TX16: first argument is not a symbol");
+        pd_error(x, "packxbee_TX16: first argument is not a symbol");
         return;
     }
     if ((argv[0].a_w.w_symbol->s_name[0] != '0')||(argv[0].a_w.w_symbol->s_name[1] != 'x'))
     {
-        error("packxbee_TX16: first argument is not a hex string beginning with \"0x\"");
+        pd_error(x, "packxbee_TX16: first argument is not a hex string beginning with \"0x\"");
         return;
     }
     result = sscanf(argv[0].a_w.w_symbol->s_name, "0x%X", &dest16);
     if (result == 0)
     {
-        error("packxbee_TX16: first argument is not a hex string");
+        pd_error(x, "packxbee_TX16: first argument is not a hex string");
         return;
     }
     if (x->x_verbosity > 1) post ("packxbee_TX16: dest16: 0x%X", dest16);
@@ -454,7 +454,7 @@
     /* options is a single byte as a float */
     if (argv[1].a_type != A_FLOAT)
     {
-        error("packxbee_TX16: second argument is not a float");
+        pd_error(x, "packxbee_TX16: second argument is not a float");
         return;
     }
     f = argv[1].a_w.w_float;
@@ -496,7 +496,7 @@
             d = ((unsigned int)f)&0x0FF;
             if (f != d)
             {
-                error ("packxbee_TX16: argument %d is not a positive integer from 0 to 255", k+1);
+                pd_error(x, "packxbee_TX16: argument %d is not a positive integer from 0 to 255", k+1);
                 return;
             }
             floatstring[i++] = d;
@@ -511,7 +511,7 @@
         }
         else
         {
-            error("packxbee_TX16: argument %d is not a float or a symbol", k+1);
+            pd_error(x, "packxbee_TX16: argument %d is not a float or a symbol", k+1);
             return;
         }
     }
@@ -552,7 +552,7 @@
     x->x_frameType = Remote_Command_Request;/* we're building a remote AT frame */
     if (argc < 3)
     {
-        error("packxbee_RAT: not enough parameters");
+        pd_error(x, "packxbee_RAT: not enough parameters");
         return;
     }
     packxbee_pack_remote_frame(x, s, argc, argv);
@@ -579,12 +579,12 @@
         /* first arg is dest64, a symbol starting with "0x" */
         if (argv[0].a_type != A_SYMBOL)
         {
-            error("packxbee_pack_remote_frame: first argument is not a symbol");
+            pd_error(x, "packxbee_pack_remote_frame: first argument is not a symbol");
             return;
         }
         if ((argv[0].a_w.w_symbol->s_name[0] != '0')||(argv[0].a_w.w_symbol->s_name[1] != 'x'))
         {
-            error("packxbee_pack_remote_frame: first argument is not a hex string beginning with \"0x\"");
+            pd_error(x, "packxbee_pack_remote_frame: first argument is not a hex string beginning with \"0x\"");
             return;
         }
 #ifdef _MSC_VER
@@ -594,7 +594,7 @@
 #endif
         if (result == 0)
         {
-            error("packxbee_pack_remote_frame: first argument is not a hex string");
+            pd_error(x, "packxbee_pack_remote_frame: first argument is not a hex string");
             return;
         }
 #ifdef _MSC_VER
@@ -605,25 +605,25 @@
         /* second arg is dest16 also a symbol starting with "0x" */
         if (argv[1].a_type != A_SYMBOL)
         {
-            error("packxbee_pack_remote_frame: second argument is not a symbol");
+            pd_error(x, "packxbee_pack_remote_frame: second argument is not a symbol");
             return;
         }
         if ((argv[1].a_w.w_symbol->s_name[0] != '0')||(argv[1].a_w.w_symbol->s_name[1] != 'x'))
         {
-            error("packxbee_pack_remote_frame: second argument is not a hex string beginning with \"0x\"");
+            pd_error(x, "packxbee_pack_remote_frame: second argument is not a hex string beginning with \"0x\"");
             return;
         }
         result = sscanf(argv[1].a_w.w_symbol->s_name, "0x%X", &dest16);
         if (result == 0)
         {
-            error("packxbee_pack_remote_frame: second argument is not a hex string");
+            pd_error(x, "packxbee_pack_remote_frame: second argument is not a hex string");
             return;
         }
         if (x->x_verbosity > 0) post ("packxbee_pack_remote_frame: dest16: 0x%X", dest16);
         /* options is a single byte as a float */
         if (argv[2].a_type != A_FLOAT)
         {
-            error("packxbee_pack_remote_frame: third argument is not a float");
+            pd_error(x, "packxbee_pack_remote_frame: third argument is not a float");
             return;
         }
         f = argv[2].a_w.w_float;
@@ -775,7 +775,7 @@
     } /* argc >= 4 */
     else
     {
-        error("packxbee_pack_remote_frame: not enough parameters");
+        pd_error(x, "packxbee_pack_remote_frame: not enough parameters");
         return;
     }
     length = i-3;
--- pd-mrpeach.orig/net/tcpreceive.c
+++ pd-mrpeach/net/tcpreceive.c
@@ -224,7 +224,7 @@
         }
         else
         {
-            error ("tcpreceive: Too many connections");
+            pd_error(x, "tcpreceive: Too many connections");
             sys_closesocket(fd);
         }
     }
--- pd-mrpeach.orig/xbee/unpackxbee.c
+++ pd-mrpeach/xbee/unpackxbee.c
@@ -62,13 +62,13 @@
 static void unpackxbee_API(t_unpackxbee *x, t_float api)
 {
     if ((api == 1) || (api ==2)) x->x_api_mode = api;
-    else error ("unpackxbee: api mode must be 1 or 2");
+    else pd_error(x, "unpackxbee: api mode must be 1 or 2");
 }
 
 static void unpackxbee_verbosity(t_unpackxbee *x, t_float verbosity_level)
 {
     if (verbosity_level >= 0) x->x_verbosity = verbosity_level;
-    else error ("packxbee: verbosity_level must be positive");
+    else pd_error(x, "packxbee: verbosity_level must be positive");
 }
 
 static int unpackxbee_add(t_unpackxbee *x, unsigned char d)
